bin/mdw-sbuild: Introduce a new `$signp' variable.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
80echo "Installing packages..."
81systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84"
85[ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
119echo " all done."
120
121###--------------------------------------------------------------------------
122### Install global configuration.
123
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
132## Symlink the various dotfiles into place
133dotfiles="
134 bash_profile bash_logout bashrc inputrc bash_completion
135 emacs emacs-calc vm gnus.el ercrc.el
136 vimrc mg zile lesskey
137 ditz-config
138 mailrc signature muttrc
139 cgrc tigrc
140 gdbinit
141 guile
142 rcrc
143 toprc
144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
145 pulse-daemon.conf:.pulse/daemon.conf
146 aspell.conf
147 tclshrc:.tclshrc tclshrc:.wishrc
148 lisp-init.lisp:.cmucl-init.lisp
149 lisp-init.lisp:.sbclrc
150 lisp-init.lisp:.clisprc.lisp
151 lisp-init.lisp:.eclrc
152 swank.lisp
153 mdw-build.conf:.config/mdw-build.conf
154 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
155 dircolors colordiffrc screenrc cvsrc indent.pro"
156[ "$xstuff" ] && dotfiles="$dotfiles
157 xinitrc xsession xmodmap vncrc vncsession
158 fonts.conf
159 stalonetrayrc
160 putty-defaults:.putty/sessions/Default%20Settings
161 mdw.session:.config/gnome-session/sessions/mdw.session
162 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
163 e-keybindings.cfg:.enlightenment/keybindings.cfg
164 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
165 e16-bindings:.e16/bindings.cfg"
166echo "Installing dotfiles..."
167for d in $dotfiles; do
168 target=.$d
169 case $d in
170 *:*) target=${d#*:} d=${d%%:*};;
171 esac
172 ft=$HOME$sub/$target
173 dir=${ft%/*}
174 mkdir -p $dir
175 ln -s $here/dot/$d $ft.new
176 mv $ft.new $ft
177 echo " $target"
178done
179echo " all done."
180
181## CPP-hack files which need it.
182cppfiles=""
183[ "$xstuff" ] && cppfiles="$cppfiles
184 Xdefaults"
185echo "Hacking files with C preprocessor..."
186for c in $cppfiles; do
187 target=.$c
188 case $c in
189 *:*) target=${c#*:} c=${c%%:*};;
190 esac
191 ft=$HOME$sub/$target
192 dir=${ft%/*}
193 mkdir -p $dir
194 cpp -P dot/$c -o $ft.new
195 mv $ft.new $ft
196 echo " $target"
197done
198echo " all done."
199
200## Substitute things which need substituting.
201dotfilessubst="
202 gitconfig
203 mykermrc
204 pulse-default.pa.in:.pulse/default.pa"
205echo "Installing dotfiles with substitutions..."
206for d in $dotfilessubst; do
207 case $d in
208 *:*) target=${d#*:} d=${d%%:*};;
209 *) target=.$d d=$d.in;;
210 esac
211 ft=$HOME$sub/$target
212 dir=${ft%/*}
213 mkdir -p $dir
214 sed "
2151i\\
216### generated by $here/setup; do not edit!\\
217
218/@home@/ s\a\a$HOME\ag
219/@profile@/ s\a\a$here\ag
220/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
221" dot/$d >$ft.new
222 mv $ft.new $ft
223 echo " $target"
224done
225echo " all done."
226
227## Symlink backgrounds.
228backgrounds="
229 bsg-supper.jpg
230 harley-quinn.jpg
231 hypatia.jpg
232 jue-peek.jpg
233 lilith.jpg
234 lovelace.jpg
235 medusa.jpg
236 noodly.jpg
237 rayne.jpg
238"
239if [ "$xstuff" ]; then
240 echo "Installing backgrounds..."
241 for b in $backgrounds; do
242 for e in enlightenment e16; do
243 dir=$HOME$sub/.$e/backgrounds
244 t=$dir/$b
245 mkdir -p $dir
246 ln -s $here/bg/$b $t.new
247 mv $t.new $t
248 done
249 echo " $b"
250 done
251 echo " all done."
252fi
253
254###--------------------------------------------------------------------------
255### Install useful scripts included in this package.
256
257scripts="
258 mdw-editor
259 mdw-pager
260 mdw-conf
261 mdw-build mdw-sbuild mdw-sbuild-server
262 update-buildable-branch
263 emacsclient-hack
264 movemail-hack
265 sendmail-hack
266 aspell-hack
267 emerge-hack
268 lesspipe.sh
269 run-with-shell-env
270 start-ssh-agent
271 start-ssh-pageant
272 svnwrap
273 guest-console
274 hyperspec"
275[ "$xstuff" ] && scripts="$scripts
276 xinitcmd
277 un-backslashify-selection
278 lock-screen
279 xpra-start-xdummy
280 xshutdown"
281echo "Installing scripts..."
282mkdir -p $HOME$sub/bin
283for s in $scripts; do
284 ft=$HOME$sub/bin/$s
285 ln -s $here/bin/$s $ft.new
286 mv $ft.new $ft
287 echo " $s"
288done
289echo " all done."
290
291hacks="
292 ssh:ssh"
293echo "Installing hacks..."
294for h in $hacks; do
295 d=${h%%:*} h=${h#*:}
296 ft=$HOME$sub/bin/hacks/$d
297 mkdir -p $ft
298 ln -s $here/hacks/$h $ft/$h.new
299 mv $ft/$h.new $ft/$h
300 echo " $d:$h"
301done
302echo " all done."
303
304###--------------------------------------------------------------------------
305### Set up the Emacs config.
306
307$echon "Finding a suitable emacs:$echoc"
308emacs=no
309for i in emacs22 emacs23 emacs21 emacs; do
310 if type -p >/dev/null $i; then
311 emacs=$i
312 break
313 fi
314done
315if [ $emacs = no ]; then
316 echo " failed."
317 emacs=:
318else
319 echo " $emacs."
320fi
321
322echo "Installing Emacs packages..."
323emacspkg="
324 make-regexp
325 ew-hols
326 mdw-gnus-patch
327 git git-blame vc-git stgit
328 mdw-multiple-cursors
329 quilt"
330for elib in $emacspkg; do
331 $echon " $elib:$echoc"
332 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
333 (progn
334 (setq load-path (nconc load-path (list "~/lib/emacs")))
335 (kill-emacs (condition-case nil
336 (progn (load-library "'"$elib"'") 0)
337 (error 1))))'; then
338 echo " already installed."
339 else
340 if [ -f el/$elib.el ]; then
341 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
342 else
343 $echon " downloading$echoc"
344 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
345 fi
346 $echon " compiling$echoc"
347 (cd $HOME$sub/lib/emacs;
348 $emacs >/dev/null 2>&1 --no-site-file --batch \
349 --eval '(byte-compile-file "'"$elib.el"'")')
350 echo " done."
351 fi
352done
353echo " all done."
354
355$echon "Setting up Emacs configuration:$echoc"
356$echon " linking$echoc"
357for f in dot-emacs.el Makefile; do
358 set -- $(echo $link | tr : ' ')
359 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
360 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
361done
362$echon " compiling$echoc"
363{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
364echo " done."
365
366###----- That's all, folks --------------------------------------------------